#include "encString.hpp"
#include <base64.h>
#include <libb64/cdecode.h>
#include <ACPU.hpp>

bool isBase64(const char *p)
{
    char c;

    if (!p)
        return false;
    if (strlen(p) % 4 != 0)
        return false;
    do {
        c = *p;
        if (isalnum(c))   // alphanumerics are OK
            continue;
        if (c == '/' || c == '+' || c == '=')   // + or / or = is OK.
            continue;
        return false;
    } while (*++p != 0);
    return true;
}

void strEncode(String &str)
{

    const char *src = &str[0];
    uint8_t key[4];
    unsigned int enciphidx = 0;
    char c;
    unsigned int i;
    uint32_t cid = ACPU::getChipId();
    auto *pkey = (uint32_t *)&key[0];
    uint8_t data[str.length()];

    *pkey = cid;
    for (i = 0; i < str.length(); i++) {
        c = src[i];
        c ^= key[enciphidx];
        ++enciphidx;
        enciphidx %= sizeof(key);
        data[i] = c;
    }
#if defined(ESP8266)
    str = base64::encode(data, str.length(), false);
#else
    str = base64::encode(data, str.length());
#endif
}

void strDecode(String &str)
{

    const char *src = &str[0];
    uint8_t key[4];
    uint32_t cid = ACPU::getChipId();
    auto *pkey = (uint32_t *)&key[0];
    uint8_t data[str.length()];
    String result = F("");

    if (isBase64(str.c_str())) {
        unsigned int clen = base64_decode_chars(src, str.length(), (char *)data);

        if (0 != clen) {
            unsigned int enciphidx = 0;
            unsigned int i;
            uint8_t b;

            *pkey = cid;
            for (i = 0; i < clen; i++) {
                b = data[i];
                b ^= key[enciphidx];
                ++enciphidx;
                enciphidx %= sizeof(key);
                result.concat(char(b));
            }
        }
    }
    str = result;
}
